/**
 * @package css-modules-types-loader
 * @license MIT
 * @version 0.5.12
 * @author nuintun <nuintun@qq.com>
 * @description A webpack loader that dynamically generates TypeScript typings for CSS modules from css-loader.
 * @see https://github.com/nuintun/css-modules-types-loader#readme
 */

import { writeFile } from 'fs/promises';
import { generateTypings, removeFile } from './utils.js';

/**
 * @module generate
 */
async function generate({ eol, path, banner, content }) {
  const typings = generateTypings(content, banner, eol);
  if (typings) {
    await writeFile(path, typings);
  } else {
    await removeFile(path);
  }
}

export { generate as default };
